const TFTB_finder = Components.classes['@mozilla.org/embedcomp/rangefind;1'].createInstance().QueryInterface(Components.interfaces.nsIFind);
const TFTB_History = Components.classes["@mozilla.org/satchel/form-history;1"].getService(Components.interfaces.nsIFormHistory2 || Components.interfaces.nsIFormHistory);
const TFTB_Sound = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
const TFTB_PrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
const TFTB_Branch = TFTB_PrefService.getBranch("TorrentFinderToolbar.");
const TFTB_REF_URI = Components.Constructor("@mozilla.org/network/standard-url;1", "nsIURI");
var TFTB_REF = new TFTB_REF_URI;
TFTB_REF.spec = 'http://torrent-finder.com/toolbar.php';
var TFTB_Update_url = 'http://torrent-finder.com/sitelist.js.php?v=3';
var TFTB_images_url = 'http://torrent-finder.com/images/logos/';
var TFTB_ClickSelectsAll = false;
var TFTB_SearchInTab = false;
var TFTB_RememberSearchType = false;
var TFTB_WarnOnFormHistory = false;
var TFTB_MaintainHistory = false;
var TFTB_EnableAutoComplete = false;
var TFTB_UseInlineComplete = false;
var TFTB_AutoSearch = false;
var TFTB_PromptToClear = false;
var TFTB_CtrlSearch = false;
var TFTB_TB_ShowLabels = false;
var TFTB_TB_ShowHighlighter = false;
var TFTB_TB_Web = false;
var TFTB_TB_ShowSearchWords = false;
var TFTB_CM_ShowContext = false;
var TFTB_FR_args	= "";
var TFTB_FR_sites	= "";
var TFTB_slist	= "";
var TFTB_GURL = '';
var TFTB_IgnoreClick = false;
var TFTB_IgnoreFocus = false;
var TFTB_OneTime = false;
var TFTB_Overflowing = false;
var TFTB_TermsSelected = false;
var TFTB_FR_Options = new Array();
var TFTB_FR_unselected = '';
var TFTB_CR_URL= '';
var TFTB_strings = '';
var TFTB_selected = 0;
var TFTB_lastkey = '';
var TFTB_UpdateDebug = true;
var TFTB_StylesArray = new Array("-moz-image-region: rect(0px 32px 16px 16px);",
								"-moz-image-region: rect(0px 48px 16px 32px);",
								"-moz-image-region: rect(0px 64px 16px 48px);",
								"-moz-image-region: rect(0px 80px 16px 64px);",
								"-moz-image-region: rect(0px 96px 16px 80px);",
								"-moz-image-region: rect(0px 112px 16px 96px);");
var TFTB_HighlightColors = new Array("#FF0;", "#0FF;", "#0F0;",	"#F0F;", "orange;", "dodgerblue;");
var TFTB_Listener =
{
	QueryInterface: function(aIID)
	{
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		aIID.equals(Components.interfaces.nsISupports))
		return this;
		throw Components.results.NS_NOINTERFACE;
	},
	onProgressChange: function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
	onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
	onSecurityChange: function(aWebProgress, aRequest, aState) {},
	onLinkIconAvailable: function(a) {},
	onStateChange: function (aWebProgress, aRequest, aStateFlags, aStatus)
	{
		if(aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP ) 
		{
			TFTB_URLChanged();
		}
	},
	onLocationChange: function(aProgress, aRequest, aLocation){ 
		if(aLocation ){
			TFTB_CR_URL = aLocation.spec;
			if(TFTB_CR_URL.indexOf('http://torrent-finder.com/TFTB-arrangesites.php?tellTFTB=update') != -1){
				TFTB_getContents(TFTB_Update_url, false);
				TFTB_LoadURL('http://torrent-finder.com/',false);
			}else TFTB_URLChanged();
		}
	}
};
function TFTB_URLChanged(){
	var hbutton = $("TFTB-TB-Highlighter");
	if(hbutton.checked == true) TFTB_AddHighlighting(null);
	if(TFTB_CR_URL.indexOf('torrent-finder.com') != -1)
	{
		var terms = '';
		if(/^[^?]*\?.*?(kw|kywrd)=([^&]*)/.test(TFTB_CR_URL)) terms = RegExp.$2;
		else  terms = TFTB_getCookie('.torrent-finder.com');
		if(terms != ''){
			terms = decodeURIComponent(terms);
			terms = TFTB_TrimString(terms.replace(/(\+)|(&[^;]+;)/g, " "));
			var searchTerms = TFTB_GetSearchTerms();
			TFTB_SetSearchTerms(terms);
			TFTB_TermsHaveUpdated();
			if(TFTB_MaintainHistory)
				TFTB_History.addEntry("TFTB-Search-History", terms);
		}
	}
}
function TFTB_RemoveListener()
{
	window.getBrowser().removeProgressListener(TFTB_Listener);
}

function TFTB_About()
{
    window.openDialog("chrome://tftoolbar/content/about.xul", TFTB_strings.getString("TFTB_about_title"), "centerscreen,chrome,modal");
}

function TFTB_AddSearchWordButton(term)
{
	TFTB_FixTBMode();
	var searchWordsContainer = $("TFTB-TB-SearchWordsContainer");
	var highlighter = $("TFTB-TB-Highlighter");
	var overflowButton = $("TFTB-Overflow-Button");
	var overflowMenu = $("TFTB-Overflow-Menu");
	var searchTerms = TFTB_SplitTerms(term);
	var tempButton;
	var tempMenuItem;
	for(var i=0; i<searchTerms.length; i++)
	{
		var thisTerm = searchTerms[i];
		var safeTerm = thisTerm.replace(/'/g, "\\'");
		safeTerm = "\'" + safeTerm + "\'";
		tempButton = document.createElement("toolbarbutton");
		tempButton.setAttribute("label",  thisTerm);
		tempButton.setAttribute("collapsed", false);
		tempButton.setAttribute("tooltiptext", TFTB_strings.getFormattedString("TFTB_FindNextOccurrence", [thisTerm]));
		tempButton.setAttribute("oncommand", "TFTB_FindInPage(" + safeTerm + ", event)");
		tempButton.className = "TFTB-TB-SearchWordButton";
		searchWordsContainer.appendChild(tempButton);
		tempMenuItem = document.createElement("menuitem");
		tempMenuItem.setAttribute("label",  thisTerm);
		tempMenuItem.setAttribute("collapsed", true);
		tempMenuItem.setAttribute("tooltiptext", TFTB_strings.getFormattedString("TFTB_FindNextOccurrence", [thisTerm]));
		tempMenuItem.setAttribute("oncommand", "TFTB_FindInPage(" + safeTerm + ", event)");
		if(highlighter.checked == true)
		{
			tempButton.setAttribute("style", TFTB_StylesArray[i%6] + " !important");
			tempMenuItem.setAttribute("style", TFTB_StylesArray[i%6] + " !important");
		}
		overflowMenu.appendChild(tempMenuItem);
	}
	TFTB_Resize(null); 
}
function TFTB_AutoSearchWhenSelected(event)
{
	if(TFTB_AutoSearch) TFTB_PrepareSearch(event, "");
}
function TFTB_CheckHighlighting()
{
	var hbutton = $("TFTB-TB-Highlighter");
	var searchWordsContainer = $("TFTB-TB-SearchWordsContainer");
	if(searchWordsContainer.childNodes.length > 0)
		hbutton.setAttribute("disabled", false);
	else
		hbutton.setAttribute("disabled", true);
}
function TFTB_ClearHistory()
{
	TFTB_History.removeEntriesForName("TFTB-Search-History");
	TFTB_SetSearchTerms("");			
	TFTB_ClearSearchWordButtons();	
	var hb = $("TFTB-TB-Highlighter");
	if(hb.checked == true)
	{
		hb.checked = false;
		TFTB_RemoveHighlighting(null);
	}
}
function TFTB_ClearHistoryPrompt()
{ 
	if(TFTB_PromptToClear){
		if (confirm(TFTB_strings.getString("TFTB_Historyprompt")))
		  TFTB_ClearHistory();
	}else
		TFTB_ClearHistory();
}
function TFTB_ClearSearchWordButtons()
{
	var i=0;
	var searchWordsContainer = $("TFTB-TB-SearchWordsContainer");
	for(i=searchWordsContainer.childNodes.length; i > 0; i--)
		searchWordsContainer.removeChild(searchWordsContainer.childNodes[0]);
	var overflowMenu = $("TFTB-Overflow-Menu");
	for(i=overflowMenu.childNodes.length; i > 0; i--)
		overflowMenu.removeChild(overflowMenu.childNodes[0]);
}
function TFTB_ConvertTermsToURI(terms)
{
	var termArray = new Array();
	termArray = terms.split(" ");
	var result = "";
	for(var i=0; i<termArray.length; i++)
	{
		if(i > 0) { result += "+"; }
		result += TFTB_MakeSafe(termArray[i]);
	}
	return result;
}
function TFTB_DisableSearchHistory()
{
	TFTB_Branch.setBoolPref("maintain_history", false);
	TFTB_UpdateSearchBoxSettings();
	TFTB_Branch.setBoolPref("warn_on_form_history", false);
}
function TFTB_EnableFormHistory()
{
	var b = TFTB_PrefService.getBranch("browser.");
	b.setBoolPref("formfill.enable", true);
	TFTB_Branch.setBoolPref("warn_on_form_history", false);
}
function TFTB_FindInPage(term, e)
{
	var found = false;
	var focusedWindow = document.commandDispatcher.focusedWindow;
	if (!focusedWindow || focusedWindow == window)
		focusedWindow = window._content;
	var findInst = getBrowser().webBrowserFind;
	var findInFrames = findInst.QueryInterface(Components.interfaces.nsIWebBrowserFindInFrames);
	findInFrames.rootSearchFrame = window._content;
	findInFrames.currentSearchFrame = focusedWindow;
	findInst.searchString = term;
	if(e)
	{
		findInst.searchFrames	= true;
		findInst.wrapFind		= true;
		findInst.entireWord		= e.altKey;
		findInst.findBackwards	= e.shiftKey;
		findInst.matchCase		= e.ctrlKey;
		if(findInst.entireWord)
			findInst.searchString  = ' ' + str + ' ';
	}
	try{ found = findInst.findNext(); }catch(er){dump(er);}
	var thisTerm = "\'" + term + "\'";
	if (!found)
	{
		TFTB_Sound.beep();
		window._content.status = TFTB_strings.getFormattedString("TFTB_TermNotFound", [thisTerm]);
	}
}
function TFTB_GetSearchTerms()
{
	return $("TFTB-SearchBox").value;
}
function TFTB_GetSearchType(event)
{
	if(!event)
		return "TF-All";
	if(event.ctrlKey && TFTB_CtrlSearch)
		return $("TFTB-TB-SearchType").getAttribute("searchType");
	return "TF-All"; 
}
function TFTB_Init()
{
	var mainItem = $("TFTB-MainMenu");
	if(!mainItem){
		$("TFTB-Toolbar").currentSet ='TFTB-Toolbar-MainItem';
		$("TFTB-Toolbar").setAttribute('currentset','TFTB-Toolbar-MainItem');
		TFTB_Init();
		return;
	}
	TFTB_strings = $("tftoolbar_strings");
	if(mainItem && TFTB_OneTime == false)
	{
		TFTB_OneTime = true;
		window.getBrowser().addProgressListener(TFTB_Listener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
		TFTB_LoadPrefs();
		TFTB_ShowBackNext();
		TFTB_UpdateButtons();
		TFTB_UpdateContextMenuVisibility();
		TFTB_UpdateSearchBoxSettings();
		TFTB_drawList(false);
		
		if(window.opener != null)
		{
			var osb = window.opener.$("TFTB-SearchBox");
			$("TFTB-SearchBox").value = osb.value;
			setTimeout("TFTB_TermsHaveUpdated()", 1);
		}else
			setTimeout("TFTB_AutoUpdator()", 15);
		setTimeout("TFTB_ValidateSearchHistorySetting()", 10);
		setTimeout("TFTB_FixTBMode()", 20);
	}
}
function TFTB_LoadPrefs()
{
	TFTB_ClickSelectsAll		= TFTB_Branch.getBoolPref("click_selects_all");
	TFTB_SearchInTab			= TFTB_Branch.getBoolPref("search_in_tab");
	TFTB_WarnOnFormHistory	= TFTB_Branch.getBoolPref("warn_on_form_history");
	TFTB_MaintainHistory		= TFTB_Branch.getBoolPref("maintain_history");
	TFTB_EnableAutoComplete	= TFTB_Branch.getBoolPref("enable_auto_complete");
	TFTB_UseInlineComplete	= TFTB_Branch.getBoolPref("use_inline_complete");
	TFTB_AutoSearch 			= TFTB_Branch.getBoolPref("auto_search");
	TFTB_PromptToClear 		= TFTB_Branch.getBoolPref("prompt_to_clear");
	TFTB_CtrlSearch 		= TFTB_Branch.getBoolPref("isctrl_search");
	TFTB_TB_ShowLabels 		= TFTB_Branch.getBoolPref("buttons.showlabels");
	TFTB_TB_ShowHighlighter = TFTB_Branch.getBoolPref("buttons.highlighter");
	TFTB_TB_Web = TFTB_Branch.getBoolPref("buttons.web");
	TFTB_TB_ShowSearchWords = TFTB_Branch.getBoolPref("buttons.searchwords");
	TFTB_CM_ShowContext 		= TFTB_Branch.getBoolPref("context.showcontext");
	TFTB_FR_args 	= TFTB_Branch.getCharPref("form.args");
	TFTB_FR_sites 	= TFTB_Branch.getCharPref("form.sites");
	TFTB_FR_unselected = TFTB_Branch.getCharPref("form.unselectedsites");
	eval(TFTB_Branch.getCharPref("form.sitelist"));
	TFTB_FR_Options = TFTB_FR_args.split(",");

}
function TFTB_LoadURL(url, openTab)
{
	if(openTab)
	{
        var newTab = getBrowser().addTab(url, TFTB_REF, null, null);
        getBrowser().selectedTab = newTab;
	}
	else
	{
		getBrowser().webNavigation.loadURI(url, Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE, TFTB_REF, null, null);
	}
	
}
function TFTB_MakeSafe(term)
{
	var safeTerm = encodeURIComponent(term);
	safeTerm = safeTerm.replace(/\'/g, '%27');
	return safeTerm;
}
function TFTB_OpenInTab(aEvent, allowAltKey)
{
	if(aEvent == null)
		aEvent = { ctrlKey:false, altKey:false, button:0 };
	if(window._content.document.location != "about:blank" && TFTB_SearchInTab)
		return true;
	var alt = aEvent.altKey;
	var ctrl = aEvent.ctrlKey;
	if(allowAltKey)
		return alt;
	if(ctrl)
		return true;
	return false;
}
function TFTB_OpenOptions()
{
	window.openDialog("chrome://tftoolbar/content/options.xul", TFTB_strings.getString("TFTB_options_title"), "centerscreen,chrome,modal");
}
function TFTB_OptionsHaveUpdated()
{
	TFTB_LoadPrefs(); 
	TFTB_UpdateButtons();
	TFTB_UpdateContextMenuVisibility();
	TFTB_UpdateSearchBoxSettings();
	TFTB_Resize(null); 
	TFTB_ValidateSearchHistorySetting();
}
function TFTB_PrepareSearch(event, searchType)
{
	var useTab = TFTB_OpenInTab(event, false);
	$("TFTB-menupopup").hidePopup();
	if(searchType == "")
		searchType = TFTB_GetSearchType(event);
	else if(searchType != 'TF-All' && searchType != 'websearch')
			$("TFTB-TB-SearchType").setAttribute("searchType", searchType);
	var searchTerms = TFTB_TrimString(TFTB_GetSearchTerms());
	var isEmpty = false;
	if(searchTerms.length == 0)
		isEmpty = true;
	TFTB_Search(searchTerms, searchType, isEmpty, useTab);
}
function TFTB_PrepareSelectedSearch(aEvent)
{
	var node = document.popupNode;
	var selection = "";
	var nodeLocalName = node.localName.toLowerCase();
	if((nodeLocalName == "textarea") || (nodeLocalName == "input" && node.type == "text"))
		selection = node.value.substring(node.selectionStart, node.selectionEnd);
	else
	{
		var focusedWindow = document.commandDispatcher.focusedWindow;
        selection = focusedWindow.getSelection().toString();
	}
	if(selection.length >= 150)
		selection = selection.substring(0, 149);
	selection = TFTB_TrimString(selection); 
	var selArray = selection.split(" ");
	for(var i=0; i<selArray.length; i++)
	{
        selArray[i] = selArray[i].replace(/^(\&|\(|\)|\[|\]|\{|\}|\"|,|\.|!|\?|'|:|;)+/, "");
        selArray[i] = selArray[i].replace(/(\&|\(|\)|\[|\]|\{|\}|\"|,|\.|!|\?|'|:|;)+$/, "");
	}
	selection = selArray.join(" ");
	if(selection != ''){
		TFTB_SetSearchTerms(selection);
		TFTB_TermsHaveUpdated();
	}
	var useTab = TFTB_OpenInTab(aEvent, false);
	searchType = TFTB_GetSearchType(aEvent);
	TFTB_Search(selection, searchType, false, useTab);
}

function TFTB_AddHighlighting(win)
{
    try {
      if(!win){ 
		win = window._content; 
		win.addEventListener('mousedown', TFTB_ReHighlight, false);
	  }
      for (var i=0; win.frames && i < win.frames.length; i++) TFTB_AddHighlighting(win.frames[i]);
	  var doc = win.document;
	  if (!doc) return;
	  var body = doc.body;
	  if (!body) return;
	  var count = body.childNodes.length;
	  var terms = TFTB_TrimString(TFTB_GetSearchTerms());
	  var termsArray = TFTB_SplitTerms(terms);
	  for(i = 0; i < termsArray.length; i++) {
		 var term = termsArray[i];
		 var layer = doc.createElement("layer");
		 layer.setAttribute("style", "background-color: " + TFTB_HighlightColors[i % TFTB_HighlightColors.length]);
		 layer.setAttribute("class", "TFTB-Highlight");
		 var searchRange = doc.createRange();
		 searchRange.setStart(body,  0);
		 searchRange.setEnd(body, count);
		 var start = doc.createRange();
		 start.setStart(body, 0);
		 start.setEnd(body, 0);
		 var end = doc.createRange();
		 end.setStart(body, count);
		 end.setEnd(body, count);
		 var result = null;
		 while ((result = TFTB_finder.Find(term, searchRange, start, end))) {
			var surround = layer.cloneNode(true);
			var startContainer = result.startContainer;
			var startOffset = result.startOffset;
			var endOffset = result.endOffset;
			var docfrag = result.extractContents();
			var before = startContainer.splitText(startOffset);
			var parent = before.parentNode;
			if ((parent.parentNode != undefined) && (parent.parentNode.nodeName.toLowerCase() == "input")) {
			   parent.insertBefore(docfrag, before);
			   surround = parent;
			}else {
			   surround.appendChild(docfrag);
			   parent.insertBefore(surround, before);
			}
			start = surround.ownerDocument.createRange();
			start.setStart(surround, surround.childNodes.length);
			start.setEnd(surround, surround.childNodes.length);            
		 }
	  }
	}
	catch (e) {
	  dump(e);
	}
}
function TFTB_RemoveHighlighting(win)
{
	if(!win)
		win = window.self;
	if(win == window._content)
		win.removeEventListener('mousedown', TFTB_ReHighlight, false);
	for(var i=0; win.frames && i < win.frames.length; i++) TFTB_RemoveHighlighting(win.frames[i]);
	var doc = win.document;
	if(!doc) return;
	var layer = doc.getElementsByTagName('layer');
	try{
	  for(i=0; i<layer.length;i++){
			if(layer[i].className == "TFTB-Highlight" ){
				var word = doc.createDocumentFragment();
				while(layer[i].firstChild)  word.appendChild(layer[i].firstChild);
				var parent = layer[i].parentNode;
				parent.insertBefore(word, layer[i]);
				layer[i].removeAttribute('class');
				layer[i].removeAttribute('style');
			}
	  }
	}catch(e){dump(e)}

}
function TFTB_ReHighlight(e){
	var t = e.target;
	if(/^img[0-9]+$/.test(t.parentNode.getAttribute('id'))){
		setTimeout('TFTB_AddHighlighting()',500);
	}
}
function TFTB_Resize(event)
{	
	var buttons = $("TFTB-TB-SearchWordsContainer");
	if(!buttons || !TFTB_TB_ShowSearchWords)
		return;
	var overflowMenu = $("TFTB-Overflow-Menu");
	var chevron = $("TFTB-Overflow-Button");
	var chevronWidth = 0;
	chevron.collapsed = false;
	chevronWidth = chevron.boxObject.width;
	chevron.collapsed = true;
	var available = window.innerWidth;
	if(available == 0)
        window.addEventListener('focus', TFTB_Resize, false);
	var overflowed = false;
	for(var i=0; i<buttons.childNodes.length; i++)
	{
		var button = buttons.childNodes[i];
		button.collapsed = overflowed;
		var offset = button.boxObject.x;
		if(offset + button.boxObject.width + chevronWidth > available)
		{
			overflowed = true;
			if(!button.collapsed)
				button.collapsed = true;
			if(chevron.collapsed)
				chevron.collapsed = false;
		}
	}
}
function TFTB_Search(searchTerms, searchType, isEmpty, useTab)
{
    var URL = "";
	var originalTerms = searchTerms;
	if(searchTerms == "" ) isEmpty = true;
	if(isEmpty == false)
		searchTerms = TFTB_ConvertTermsToURI(searchTerms);
	if(searchType == "TF-All")
	{
        if(isEmpty ) { 
			URL = "http://torrent-finder.com/"; 
		}else{
			if(TFTB_FR_Options[9] == 'btabs'){
				TFTB_OpenTabsGroup(0, searchTerms);
				URL = false;
			}else{
				var sites = '';
				if( TFTB_FR_sites != "") sites = "&sids=" + TFTB_FR_sites ;
				URL = "http://torrent-finder.com/show.php?q=" + searchTerms + "&Browse=" + TFTB_FR_Options[9] + "&PageLoad=" + TFTB_FR_Options[10]  + "&select=" + TFTB_FR_Options[11] + sites; 
			}
		}
	}else if(searchType == "websearch" || searchType == "google"){
		URL = TFTB_GURL + searchTerms ;
		if(searchType == "google") URL+='+filetype:torrent';
	}else
		URL = "http://torrent-finder.com/open.php?id=" + searchType + "&kw=" + searchTerms ;
	if(TFTB_MaintainHistory && !isEmpty )
		TFTB_History.addEntry("TFTB-Search-History", originalTerms);
	if(URL) TFTB_LoadURL(URL, useTab);
}
function TFTB_OpenTabsGroup(i,searchTerms){
	var d = document;
	var BackBT = d.getElementById('TFTB-Back');
	var NextBT = d.getElementById('TFTB-Next');
	var SelectedSites = new Array();
	if(TFTB_FR_sites != '')
		SelectedSites = TFTB_FR_sites.split('-');
	else
		for(var x=0 ; x<TFTB_slist.length ; x++)
			SelectedSites.push(TFTB_slist[x][0]);
	var FrSelect = (TFTB_FR_Options[11]== 'ALL') ? SelectedSites.length : parseInt(TFTB_FR_Options[11]);
	var y = i+FrSelect;
	if(y>SelectedSites.length) 
		y = SelectedSites.length;
	try{
		if(!TFTB_confirmOpenTabs(y-i)) return;
	}catch(e){dump(e)}
	
	var prv = i-(y-i);
	
	for(i ; i<y ; i++){
		if(SelectedSites[i] != '')
			TFTB_LoadURL("http://torrent-finder.com/open.php?id=" + SelectedSites[i] + "&kw=" + searchTerms, true);
	}
	if(prv > -1){
		BackBT.setAttribute('disabled', false);
		BackBT.setAttribute('oncommand', 'TFTB_OpenTabsGroup('+prv+',\''+searchTerms+'\')');
	}else BackBT.setAttribute('disabled', true);
	if(i < SelectedSites.length){
		NextBT.setAttribute('disabled', false);
		NextBT.setAttribute('oncommand', 'TFTB_OpenTabsGroup('+i+',\''+searchTerms+'\')');
	}else NextBT.setAttribute('disabled', true);

}
function TFTB_confirmOpenTabs(numTabsToOpen) 
{
	var reallyOpen = true;
	const kWarnOnOpenPref = "browser.tabs.warnOnOpen";
	if (TFTB_PrefService.getBoolPref(kWarnOnOpenPref))
	{
	  if (numTabsToOpen >= TFTB_PrefService.getIntPref("browser.tabs.maxOpenBeforeWarn"))
	  {
		var promptService = 
			Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
			getService(Components.interfaces.nsIPromptService);
		var warnOnOpen = { value: true };
		var messageKey = "tabs.openWarningMultipleBranded";
		var openKey = "tabs.openButtonMultiple";
		var buttonPressed = promptService.confirmEx(window,
			TFTB_strings.getString("TFTB_confirm_title"),
			TFTB_strings.getFormattedString("TFTB_confirm_desc", [numTabsToOpen]),
			(promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0)
			+ (promptService.BUTTON_TITLE_CANCEL * promptService.BUTTON_POS_1),
			TFTB_strings.getString("TFTB_confirm_opentabs"),
			null, null,
			TFTB_strings.getString("TFTB_confirm_warn"),
			warnOnOpen);
		 reallyOpen = (buttonPressed == 0);
		 if (reallyOpen && !warnOnOpen.value)
		   TFTB_PrefService.setBoolPref(kWarnOnOpenPref, false);
	   }
	}
	return reallyOpen;
}
function TFTB_SearchBoxClickHandler(aEvent, aElt)
{
	if(!TFTB_IgnoreClick && TFTB_ClickSelectsAll && aElt.selectionStart == aElt.selectionEnd)
		aElt.select();
}
function TFTB_SearchBoxFocusHandler(aEvent, aElt)
{
	if(TFTB_IgnoreFocus)
		TFTB_IgnoreFocus = false;
	else if(TFTB_ClickSelectsAll)
		aElt.select();
}
function TFTB_SearchBoxMouseDownHandler(aEvent, aElt)
{
	if(aElt.hasAttribute("focused"))
		TFTB_IgnoreClick = true;
	else
	{
		TFTB_IgnoreFocus = true;
		TFTB_IgnoreClick = false;
		aElt.setSelectionRange(0, 0);
	}
}
function TFTB_SearchBoxTextEntered(aTriggeringEvent)
{
	var terms = TFTB_TrimString(TFTB_GetSearchTerms());
	var isEmpty = (terms.length == 0);
	var useTab = TFTB_OpenInTab(aTriggeringEvent, true);
	var searchType = TFTB_GetSearchType(aTriggeringEvent);
	if(aTriggeringEvent != null || (aTriggeringEvent == null && TFTB_AutoSearch))
		TFTB_Search(terms, searchType, isEmpty, useTab);
}
function TFTB_SelectTerms(event)
{
	var searchBox = $("TFTB-SearchBox");
	var ePt = searchBox.inputField.textLength;
	var curClickStart = searchBox.inputField.selectionStart;
	var ePt = searchTerms.inputField.textLength;
	var curClickStart = searchTerms.inputField.selectionStart;
	var curClickEnd = searchTerms.inputField.selectionEnd;
	var curSelSize = curClickEnd - curClickStart;
	if (event && ePt > 0)
	{
		switch(event.type)
		{
		case "dblclick":
			if (!TFTB_TermsSelected)
			{
				searchTerms.inputField.select();
				TFTB_TermsSelected = true;
			}
			else
			{
				searchTerms.inputField.setSelectionRange(curClickStart, curClickEnd);
				TFTB_TermsSelected = false;
			}
			break;
		case "focus":
			if (TFTB_IgnoreFocus)
				TFTB_IgnoreFocus = false;
			else
			{
				if (TFTB_TermsSelected)
				{
					searchTerms.inputField.setSelectionRange(0, 0 );
					TFTB_TermsSelected = false;
				}
				else
				{
					searchTerms.inputField.select();
					TFTB_TermsSelected = true;
				}
			}
			break;
		case "mousedown":
			if (searchTerms.getAttribute("focused"))
				TFTB_IgnoreClick = true;
			else
			{
				TFTB_IgnoreFocus = true;
				TFTB_IgnoreClick = false;
				searchTerms.inputField.setSelectionRange(0, 0 );
				TFTB_TermsSelected = true;
			}
			break;
		case "click":
			if (!TFTB_IgnoreClick && curSelSize == 0)
			{
				searchTerms.inputField.select();
				TFTB_TermsSelected = true;
			}
			break;
		default:
			break;
		}
	}
}
function TFTB_SetFocus()
{
	$("TFTB-SearchBox").focus();
}
function TFTB_SetSearchTerms(terms)
{
	var searchbox = $("TFTB-SearchBox");
	searchbox.value = terms;
}
function TFTB_SplitTerms(searchwords)
{
	var string = TFTB_TrimString(searchwords);
	var buffer = "";
	var inQuotes = false;
	var inWord = false;
	var myArray = new Array();
	for(var i=0; i<string.length; i++)
	{
		var c = string.charAt(i);
		switch(c)
		{
		case ' ':
			if(inQuotes == false)
			{
				myArray.push(buffer);
				buffer = "";
				if(inWord == true) inWord = false;
			}
			else
				buffer += c;
			break;
		case '"':
			if(inQuotes == false) { inQuotes = true; inWord = true; }
			else				  { inQuotes = false; inWord = false; }
			break;
		case ',':
			break; 
		case '+':
		case '~':
			if(inWord == false)
				break; 
		default:
			if(inWord == false) 
				inWord = true;
			buffer += c;
		}
	}
	if(buffer != "")
		myArray.push(buffer);
	return myArray;
}
function TFTB_TermsHaveUpdated()
{
	TFTB_UpdateSearchWordButtons();
	TFTB_CheckHighlighting();
}
function TFTB_ToggleHighlighting()
{
	var hb = $("TFTB-TB-Highlighter");
	if(hb.checked == true)
	{
		hb.checked = false;
		TFTB_RemoveHighlighting(null);
	}
	else
	{
		hb.checked = true;
		TFTB_AddHighlighting(null);
	}
	TFTB_UpdateSearchWordButtons();
}
function TFTB_TrimString(string)
{
    if (!string) return "";
	string = string.replace(/^\s+/, '');
	string = string.replace(/\s+$/, '');
	string = string.replace(/\s+/g, ' ');
	return string;
}
function TFTB_UpdateButtons()
{
	var TB_SWContainer	= $("TFTB-TB-SearchWordsContainer");
	var TB_Highlighter	= $("TFTB-TB-Highlighter");
	var TB_Web	= $("TFTB-Web");
	var TB_SearchType	= $("TFTB-TB-SearchType");
	var TB_Back			= $("TFTB-Back");
	var TB_Next			= $("TFTB-Next");
	var TB_Web			= $("TFTB-Web");
	TB_Highlighter.setAttribute("collapsed", !TFTB_TB_ShowHighlighter);
	TB_Web.setAttribute("collapsed", !TFTB_TB_Web);
	TB_SWContainer.setAttribute("collapsed", !TFTB_TB_ShowSearchWords);
	if(TFTB_TB_ShowLabels == true)
	{
		TB_SearchType.setAttribute("label", TFTB_strings.getString("TFTB_TB_SearchType_Label"));
		TB_Highlighter.setAttribute("label", TFTB_strings.getString("TFTB_TB_Highlighter_Label"));
		TB_Back.setAttribute("label", TFTB_strings.getString("TFTB_TB_prv_Label"));
		TB_Next.setAttribute("label",TFTB_strings.getString("TFTB_TB_nxt_Label") );
		TB_Web.setAttribute("label",TFTB_strings.getString("TFTB_TB_web_Label") );
	}
	else
	{
		TB_SearchType.setAttribute("label", '');
		TB_Highlighter.setAttribute("label", '');
		TB_Back.setAttribute("label", '');
		TB_Next.setAttribute("label", '');
		TB_Web.setAttribute("label", '');
	}
}
function TFTB_UpdateContextMenuVisibility()
{
	var conMenu = $("TFTB-Context-Menu");
	var conSep = $("TFTB-Context-Separator");
	conMenu.setAttribute("collapsed", !TFTB_CM_ShowContext);
	conSep.setAttribute("hidden", !TFTB_CM_ShowContext);
}
function TFTB_UpdateOverflowMenu()
{
	var buttons = $("TFTB-TB-SearchWordsContainer");
	var overflowMenu = $("TFTB-Overflow-Menu");
	for(var i=0; i<buttons.childNodes.length; i++)
	{
		var button = buttons.childNodes[i];
		var menu = overflowMenu.childNodes[i];
		if(menu.collapsed == button.collapsed)
			menu.collapsed = !menu.collapsed;
	}
}
function TFTB_UpdateSearchBoxSettings()
{
	var searchBox = $("TFTB-SearchBox");
	searchBox.setAttribute("enablehistory", TFTB_MaintainHistory);
	if(TFTB_MaintainHistory)
	{
		searchBox.setAttribute("completedefaultindex", TFTB_UseInlineComplete);
		searchBox.setAttribute("disableautocomplete", !TFTB_EnableAutoComplete);
	}
	else
	{
		searchBox.setAttribute("completedefaultindex", false);
		searchBox.setAttribute("disableautocomplete", true);
	}
}
function TFTB_UpdateSearchWordButtons()
{
	TFTB_ClearSearchWordButtons();
	TFTB_AddSearchWordButton(TFTB_GetSearchTerms());
}
function TFTB_ValidateSearchHistorySetting()
{
	if(TFTB_WarnOnFormHistory)
	{
		var b = TFTB_PrefService.getBranch("browser.");
		if(b.getBoolPref("formfill.enable") == false && TFTB_Branch.getBoolPref("maintain_history") == true)
		{
			if (confirm(TFTB_strings.getString("TFTB_formfill")))
				TFTB_EnableFormHistory();
			else
				TFTB_DisableSearchHistory();
		}
	}
}
function TFTB_GetURL(URL){
	var useTab = TFTB_OpenInTab();
	TFTB_LoadURL(URL,useTab);
}
function TFTB_ToggleOptions(dsply){
	var obj = $("TFTB-more");
 	var groupbox = $("TFTB-MoreOptions");
	if(dsply)	groupbox.style.display = dsply=='show' ?  'none' : 'block';
	if(groupbox.style.display == 'block'){
		 groupbox.style.display = 'none';
		 obj.value = TFTB_strings.getString("TFTB_form_moreoptions");
		 obj.style.background = 'url("chrome://tftoolbar/skin/options.png") no-repeat left';
	}else{
		 groupbox.style.display = 'block';
		 obj.value  = TFTB_strings.getString("TFTB_form_lessoptions");
		 obj.style.background = 'url("chrome://tftoolbar/skin/options-up.png") no-repeat left';
		 $('TFTB-Browse').selectedIndex = TFTB_FR_Options[6];
		 $('TFTB-PageLoad').selectedIndex = TFTB_FR_Options[7];
		 var num = parseInt(window.innerWidth/95);
		 var slct = $('TFTB-select');
		 slct.getItemAtIndex(0).label = slct.getItemAtIndex(0).value = TFTB_FR_Options[11]>5 ? TFTB_FR_Options[11] : num;
		 slct.getItemAtIndex(3).label = slct.getItemAtIndex(3).value = num;
		 slct.getItemAtIndex(4).label = slct.getItemAtIndex(4).value = num*2;
		 slct.getItemAtIndex(5).label = slct.getItemAtIndex(5).value = num*4;
		 slct.getItemAtIndex(6).label = slct.getItemAtIndex(6).value = num*6;
		 slct.ensureIndexIsVisible(slct.selectedIndex);
	}
}
function TFTB_ToggleSelect(obj , kind){
 var groupbox = $("TFTB-menupopup-sitelist");
 var checkboxes = groupbox.getElementsByTagName("checkbox");
 var toggle = obj.checked ? true : false ;
 for(var i=0; i< checkboxes.length; i++ ){
	 if(kind=='ALL') {
		 checkboxes[i].setAttribute("checked", toggle);
		 $("TFTB-Options-prvt").setAttribute("checked", toggle);
		 $("TFTB-Options-noneng").setAttribute("checked", toggle);
		 $("TFTB-Options-anime").setAttribute("checked", toggle);
	 }
	 if(checkboxes[i].getAttribute(kind)== '1' ) checkboxes[i].setAttribute("checked", toggle);
 }
}
function TFTB_setLastChecked(){
	for(i=0; i< TFTB_slist.length; i++ ){
			$('TFTB_chk'+TFTB_slist[i][0]).setAttribute("checked", (TFTB_FR_unselected.indexOf(','+TFTB_slist[i][0]+',') == -1));
	}
}
function TFTB_getLastChecked(){
	TFTB_FR_unselected = ',';
	TFTB_FR_sites = '';
	for(i=0; i< TFTB_slist.length; i++ ){
		var site = $('TFTB_chk'+TFTB_slist[i][0]);
		if( !site.checked)
			TFTB_FR_unselected += TFTB_slist[i][0]+',';
		else
			TFTB_FR_sites += TFTB_slist[i][0]+'-';
	}
	TFTB_Branch.setCharPref("form.unselectedsites", TFTB_FR_unselected);
	TFTB_Branch.setCharPref("form.sites", TFTB_FR_sites);
}
function TFTB_getCookie(host) {
        var cookie            = null;
        var cookieEnumeration = Components.classes["@mozilla.org/cookiemanager;1"].getService(Components.interfaces.nsICookieManager).enumerator;
        var cookieHost        = null;
        var cookieName        = null;
        var name	          = 'KeyWord';
        while(cookieEnumeration.hasMoreElements())
        {
            cookie = cookieEnumeration.getNext().QueryInterface(Components.interfaces.nsICookie);
            cookieHost = cookie.host;
            cookieName = cookie.name;
            if((host == cookieHost || host.indexOf("." + cookieHost) != -1) && ( name == cookieName || name.indexOf(cookieName) == 0 ) )
			{
                return cookie.value;
			}
        }
	return false;
}
function TFTB_PP_FRShow() {
	if(!$('TFTB-menupopup-sitelist').hasChildNodes()) TFTB_drawList(false);
	TFTB_FR_args 	= TFTB_Branch.getCharPref("form.args");
	TFTB_FR_Options = TFTB_FR_args.split(",");
	$('TFTB-Options-all').setAttribute("checked", TFTB_FR_Options[0]);
	$('TFTB-Options-prvt').setAttribute("checked", TFTB_FR_Options[1]);
	$('TFTB-Options-anime').setAttribute("checked", TFTB_FR_Options[2]);
	$('TFTB-Options-noneng').setAttribute("checked", TFTB_FR_Options[3]);
	$('TFTB_Logos').setAttribute("checked", TFTB_FR_Options[4]);
	TFTB_ToggleOptions(TFTB_FR_Options[5]);
	TFTB_setLastChecked();
	$('TFTB_chk'+TFTB_slist[TFTB_selected][0]).focus();
	$('TFTB-menupopup').addEventListener("keydown", TFTB_GetSite, false);
}
function TFTB_PP_click(wch,num) {
	TFTB_FR_Options[num+3] = wch.value;
	TFTB_FR_Options[num] = wch.selectedIndex;
	TFTB_ShowBackNext();
}
function TFTB_ShowBackNext(){
	var display = (TFTB_FR_Options[9]=='btabs') ? 'block' : 'none';
	$('TFTB-Back').style.display = display;
	$('TFTB-Next').style.display = display;
	if(window.opener == null){
		$('TFTB-Back').setAttribute('disabled', true);
		$('TFTB-Next').setAttribute('disabled', true);
	}
}
function TFTB_PP_FRHide() {
	TFTB_FR_args  = "";
	TFTB_FR_args += $('TFTB-Options-all').getAttribute("checked")+",";
	TFTB_FR_args += $('TFTB-Options-prvt').getAttribute("checked")+",";
	TFTB_FR_args += $('TFTB-Options-anime').getAttribute("checked")+",";
	TFTB_FR_args += $('TFTB-Options-noneng').getAttribute("checked")+",";
	TFTB_FR_args += $('TFTB_Logos').getAttribute("checked")+",";
	TFTB_FR_args += $("TFTB-MoreOptions").style.display=='block' ? 'show'+',' : 'hide'+',';
	TFTB_FR_args += TFTB_FR_Options[6]+",";
	TFTB_FR_args += TFTB_FR_Options[7]+",";
	TFTB_FR_args += TFTB_FR_Options[8]+",";
	TFTB_FR_args += TFTB_FR_Options[9]+",";
	TFTB_FR_args += TFTB_FR_Options[10]+",";
	TFTB_FR_args += TFTB_FR_Options[11];
	TFTB_getLastChecked();
	TFTB_Branch.setCharPref("form.args", TFTB_FR_args);
	TFTB_FR_Options = TFTB_FR_args.split(",");
	$('TFTB-menupopup').removeEventListener("keydown", TFTB_GetSite, false);
}
function TFTB_AutoUpdator(){
	if(!TFTB_Branch.getBoolPref("autoupdate") || TFTB_Branch.getCharPref("lastupdate") == (new Date()).getDate() ) return;
	TFTB_UpdateDebug = false;
	TFTB_getContents(TFTB_Update_url);
}
function TFTB_alert(msg){
	if(TFTB_UpdateDebug) alert(msg);
	else dump(msg);
}
function TFTB_getContents(aURL){
	if($('TFTB_updator').getAttribute('disabled')== 'true') return;
	$('TFTB_updator').setAttribute('disabled', 'true'); 
	var req = new XMLHttpRequest();
	var stat = "";
	
	if(TFTB_UpdateDebug){
		req.onprogress = function(e)
			{
				stat += '|';
				TFTB_SetSearchTerms(TFTB_strings.getString("TFTB_update_downloading")+ stat); 
			};
	}
	req.onreadystatechange = function(e)
		{
		  if (req.readyState == 4 ) {
			if(req.status == 200){
				TFTB_setUpdate(req.responseText);
			}else 
				TFTB_alert(TFTB_strings.getFormattedString("TFTB_update_error", [req.statusText]));
		  }else
				return;
		};
	req.open('GET', aURL , true);
	req.send(null); 
}
function TFTB_setUpdate(Update){
	var TFTB_oldUpdate = TFTB_Branch.getCharPref("form.sitelist");
	if(TFTB_oldUpdate != Update){
			TFTB_Branch.setCharPref("form.sitelist", Update);
			TFTB_drawList(false);
			TFTB_alert(TFTB_strings.getString("TFTB_update_updated"));
	}else if(TFTB_oldUpdate == Update){
			TFTB_alert(TFTB_strings.getString("TFTB_update_noupdate"));
	}
	TFTB_SetSearchTerms('');
	TFTB_TermsHaveUpdated();
	$('TFTB_updator').setAttribute('disabled', false); 
	TFTB_oldUpdate = null;
	TFTB_UpdateDebug = true;
	TFTB_Branch.setCharPref("lastupdate", (new Date()).getDate());

}
function TFTB_FixTBMode(){
	var toolbar	= $("TFTB-Toolbar");
	if(toolbar.getAttribute('mode')!='text')
		toolbar.setAttribute('mode','');
	if(TFTB_Branch.getBoolPref("check_showhide_button") == false) return;
	var mainset = $('nav-bar').currentSet;
	if(mainset.indexOf('TFTB-ShowHide') == -1){
		mainset = mainset.replace(',urlbar-container', ',TFTB-ShowHide,urlbar-container');
		try{  
			$('nav-bar').currentSet = mainset;
			$("nav-bar").setAttribute('currentset', mainset); 
			$("navigator-toolbox").ownerDocument.persist('nav-bar', "currentset"); 
			BrowserToolboxCustomizeDone(true);
		} catch(e){ dump(e); } 
		TFTB_Branch.setBoolPref("check_showhide_button", false);
	}
}
function TFTB_drawList(obj){
	try{
		eval(TFTB_Branch.getCharPref("form.sitelist"));
	}catch(e){
		try{
			TFTB_Branch.clearUserPref('form.sitelist');
			eval(TFTB_Branch.getCharPref("form.sitelist"));
		}catch(e){dump(e);}
	}
	
	if(obj){
		TFTB_FR_Options[4] = $("TFTB_Logos").checked;
		TFTB_getLastChecked();
	}
	var scwidth = window.screen.availWidth-25;
	var usecache = TFTB_Branch.getBoolPref("form.usecache");
	var d           = document;
	var popup       = d.getElementById('TFTB-menupopup-sitelist');
	popup.setAttribute('style','min-width:'+scwidth+'px;');
	while(popup.hasChildNodes())
	  popup.removeChild(popup.firstChild);
	var tprow = d.createElement('rows');
	popup.appendChild(tprow);
	var hrrow;
	var x = parseInt(scwidth/110);
	for(i=0; i<TFTB_slist.length ; i++){
		name = TFTB_slist[i][0];
		if( !(i%x) ){
			hrrow = d.createElement('row');
			hrrow.setAttribute('id', 'TFTB-hrrow'+i);
			hrrow.setAttribute('style', 'min-width:'+(scwidth-5)+'px;');
			popup.appendChild(hrrow);
			myrow  = d.getElementById('TFTB-hrrow'+i);
		}
		chkbx = d.createElement('checkbox');
		chkbx.setAttribute('checked', (TFTB_FR_unselected.indexOf(','+TFTB_slist[i][0]+',') == -1));
		chkbx.setAttribute('tooltiptext', TFTB_slist[i][1] );
		chkbx.setAttribute('id', 'TFTB_chk'+name );
		if(TFTB_slist[i][2]) chkbx.setAttribute('prvt', '1' );
		if(TFTB_slist[i][3]) chkbx.setAttribute('anime', '1' );
		if(TFTB_slist[i][4]) chkbx.setAttribute('noteng', '1' );
		chkbx.setAttribute('oncommand', 'event.stopPropagation();' );
		chkbx.setAttribute('onclick', 'event.stopPropagation();' );
		myrow.appendChild(chkbx);
	
		if(TFTB_FR_Options[4]){
			lbl = d.createElement('image');
			lbl.setAttribute('src',  (usecache)?TFTB_get_image_location(name): TFTB_images_url+name+'.gif' );
			lbl.setAttribute('class', 'TFTB-logo');
		}else{
			lbl = d.createElement('label');
			lbl.setAttribute('value', TFTB_slist[i][1] );
			lbl.setAttribute('class', 'TFTB-url');
			lbl.setAttribute('prvt', TFTB_slist[i][2] );
		}
		lbl.setAttribute('tooltiptext', TFTB_slist[i][1] );
		lbl.setAttribute('onclick', 'TFTB_PrepareSearch(event,\''+name+'\');event.stopPropagation();' );
		lbl.setAttribute('id', 'TFTB_bt'+name );
		myrow.appendChild(lbl);
	}
	
}
function TFTB_get_image_location(img){
	var url = '';
	var defaulturl = TFTB_images_url+img+'.gif';	
	var newurl = 'chrome://tftoolbar/skin/logos/'+img+'.gif';
	url = TFTB_get_image(img,defaulturl,newurl);
	return url;
}
function TFTB_get_image(img,defaulturl,newurl){
	try{
		const id = "TFToolbarX@torrent-finder";
		var file = Components.classes["@mozilla.org/extensions/manager;1"]
					.getService(Components.interfaces.nsIExtensionManager)
					.getInstallLocation(id)
					.getItemLocation(id);
		file.append("chrome");
		file.append("skin");
		file.append("logos");
		file.append(img + ".gif");
		if (file.exists() && file.fileSize > 150) return newurl;
		var obj_URI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(defaulturl, null, null);
		var obj_Persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].createInstance(Components.interfaces.nsIWebBrowserPersist);
		var cachekey = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
		cachekey.data = defaulturl;
		obj_Persist.persistFlags = Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_REPLACE_EXISTING_FILES | Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_FROM_CACHE | Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_FAIL_ON_BROKEN_LINKS | Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_CLEANUP_ON_FAILURE;
		obj_Persist.saveURI(obj_URI,cachekey,null,null,null,file);
		return defaulturl;
	}catch(e){
		return defaulturl;
	}
}
function TFTB_GetSite(e){
	var TFTB_keynum = e.which;
	if(TFTB_keynum == 13){
		TFTB_PrepareSearch(e,TFTB_slist[TFTB_selected][0]);
		return;
	}
	if(TFTB_keynum == 27){
		$('TFTB-menupopup').hidePopup();
		return;
	}
	var TFTB_keychar = String.fromCharCode(TFTB_keynum).toLowerCase();
	$('TFTB_bt'+TFTB_slist[TFTB_selected][0]).removeAttribute('selected');
	for(var i=(TFTB_keychar == TFTB_lastkey)?TFTB_selected+1:0;i<TFTB_slist.length;i++){
		if(TFTB_slist[i][1].substring(0,1).toLowerCase() == TFTB_keychar){
			$('TFTB_bt'+TFTB_slist[i][0]).setAttribute('selected', 'true');
			$('TFTB_chk'+TFTB_slist[i][0]).focus();
			TFTB_selected = i;
			TFTB_lastkey = TFTB_keychar;
			return;
		}
	}
	TFTB_lastkey = '';
}
function TFTB_toggletoolbar(){
	$("TFTB-Toolbar").collapsed =  !$("TFTB-Toolbar").collapsed;
	TFTB_FixTBMode();
}
function $(id){
	return document.getElementById(id);
}